=== src/activities/babyshapes/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/babyshapes *.qml *.svg *.js resource/*/*)
