=== src/activities/bargame/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/bargame *.qml *.svg *.js resource/*)
