=== src/activities/click_on_letter/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/click_on_letter *.qml *.svg *.js resource/*)
