=== src/activities/clickanddraw/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/clickanddraw *.qml *.svg *.js resource/*)
