=== src/activities/digital_electricity/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/digital_electricity *.qml *.svg *.js resource/* components/*)
