=== src/activities/enumerate/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/enumerate *.qml *.svg *.js resource/*)
