=== src/activities/erase/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/erase *.qml *.svg *.js resource/*)
