=== src/activities/hangman/CMakeLists.txt ===
GCOMPRIS_ADD_RCC(activities/hangman *.qml *.svg *.js resource/*)
