=== debian/changelog ===
gcompris-qt (0.95-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update Vcs-* fields.
  * Bump Standards-Version to 4.2.1, no changes required.
  * Remove debian/not-installed, outdated, and unused.
  * Rename debian/docs to debian/gcompris-qt.docs, to make it explicit to which
    package it applies.
  * Switch Source to kde.org in copyright.
  * Tighten the gcompris-qt version in the transitional gcompris package.

 -- Pino Toscano <pino@debian.org>  Sun, 23 Dec 2018 10:18:07 +0100
